/**************************************************

  Super Calendar Set Demo by Andrew J. McGee
  E-Mail: jaym25@3ptech.com
  Last Revision Date: 12/19/97

  Copyright (c) 1997 by Andrew J. McGee
  This Source Code may not be distributed to any other person
  without the express written permission of the Author

  The Author may also be contacted via snail mail:
     PO Box 80336
     Baton Rouge, LA 70898 USA
****************************************************/

//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "SCalDemo1.h"
//---------------------------------------------------------------------------
#pragma link "SCalSet"
#pragma link "STools"
#pragma resource "*.dfm"
TfrmDemo1 *frmDemo1;
//---------------------------------------------------------------------------
__fastcall TfrmDemo1::TfrmDemo1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::FormCreate(TObject *Sender)
{
AreaSelectBox->ItemIndex=0;
StartDate->Text=FormatDateTime("ddddd",SCalControl1->SelDate);
EndDate->Text=FormatDateTime("ddddd",SCalControl1->SelDateEnd);
ceStartDate->Text=FormatDateTime("ddddd",SCalEdit1->SelDate);
ceEndDate->Text=FormatDateTime("ddddd",SCalEdit1->SelDateEnd);
MaskEdit1->Text=FormatDateTime("ddddd",26189);
MaskEdit2->Text=FormatDateTime("ddddd",34811);
MaskEdit3->Text=FormatDateTime("ddddd",35431);
MaskEdit4->Text=FormatDateTime("ddddd",35504);
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::FormShow(TObject *Sender)
{
PageControl1->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::ButtonColorCalCtrlClick(TObject *Sender)
{
MyColor = new TColorDialog(Application);
  switch(AreaSelectBox->ItemIndex){
    case 0: MyColor->Color=SCalControl1->Colors->MonthBackColor; break;
    case 1: MyColor->Color=SCalControl1->Colors->BorderColor; break;
    case 2: MyColor->Color=SCalControl1->Colors->TextColor; break;
    case 3: MyColor->Color=SCalControl1->Colors->TitleBackColor; break;
    case 4: MyColor->Color=SCalControl1->Colors->TitleTextColor; break;
    case 5: MyColor->Color=SCalControl1->Colors->TrailingTextColor; break;}
  if(MyColor->Execute())
    switch(AreaSelectBox->ItemIndex){
      case 0: SCalControl1->Colors->MonthBackColor=MyColor->Color; break;
      case 1: SCalControl1->Colors->BorderColor=MyColor->Color; break;
      case 2: SCalControl1->Colors->TextColor=MyColor->Color; break;
      case 3: SCalControl1->Colors->TitleBackColor=MyColor->Color; break;
      case 4: SCalControl1->Colors->TitleTextColor=MyColor->Color; break;
      case 5: SCalControl1->Colors->TrailingTextColor=MyColor->Color; break;}
delete MyColor;
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::ButtonColorCalPopClick(TObject *Sender)
{
MyColor = new TColorDialog(Application);
  switch(AreaSelectBox->ItemIndex){
    case 0: MyColor->Color=SCalPopup1->Colors->MonthBackColor; break;
    case 1: MyColor->Color=SCalPopup1->Colors->BorderColor; break;
    case 2: MyColor->Color=SCalPopup1->Colors->TextColor; break;
    case 3: MyColor->Color=SCalPopup1->Colors->TitleBackColor; break;
    case 4: MyColor->Color=SCalPopup1->Colors->TitleTextColor; break;
    case 5: MyColor->Color=SCalPopup1->Colors->TrailingTextColor; break;}
  if(MyColor->Execute())
    switch(AreaSelectBox->ItemIndex){
      case 0: SCalPopup1->Colors->MonthBackColor=MyColor->Color; break;
      case 1: SCalPopup1->Colors->BorderColor=MyColor->Color; break;
      case 2: SCalPopup1->Colors->TextColor=MyColor->Color; break;
      case 3: SCalPopup1->Colors->TitleBackColor=MyColor->Color; break;
      case 4: SCalPopup1->Colors->TitleTextColor=MyColor->Color; break;
      case 5: SCalPopup1->Colors->TrailingTextColor=MyColor->Color; break;}
delete MyColor;
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::ButtonColorCalEditClick(TObject *Sender)
{
MyColor = new TColorDialog(Application);
  switch(AreaSelectBox->ItemIndex){
    case 0: MyColor->Color=SCalEdit1->Calendar->Colors->MonthBackColor; break;
    case 1: MyColor->Color=SCalEdit1->Calendar->Colors->BorderColor; break;
    case 2: MyColor->Color=SCalEdit1->Calendar->Colors->TextColor; break;
    case 3: MyColor->Color=SCalEdit1->Calendar->Colors->TitleBackColor; break;
    case 4: MyColor->Color=SCalEdit1->Calendar->Colors->TitleTextColor; break;
    case 5: MyColor->Color=SCalEdit1->Calendar->Colors->TrailingTextColor; break;}
  if(MyColor->Execute())
    switch(AreaSelectBox->ItemIndex){
      case 0: SCalEdit1->Calendar->Colors->MonthBackColor=MyColor->Color; break;
      case 1: SCalEdit1->Calendar->Colors->BorderColor=MyColor->Color; break;
      case 2: SCalEdit1->Calendar->Colors->TextColor=MyColor->Color; break;
      case 3: SCalEdit1->Calendar->Colors->TitleBackColor=MyColor->Color; break;
      case 4: SCalEdit1->Calendar->Colors->TitleTextColor=MyColor->Color; break;
      case 5: SCalEdit1->Calendar->Colors->TrailingTextColor=MyColor->Color; break;}
delete MyColor;
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::ButtonFontCalControlClick(TObject *Sender)
{
MyFont = new TFontDialog(Application);
MyFont->Font = SCalControl1->Font;
if(MyFont->Execute()) SCalControl1->Font = MyFont->Font;
delete MyFont;
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::ButtonFontCalPopupClick(TObject *Sender)
{
MyFont = new TFontDialog(Application);
MyFont->Font = SCalPopup1->Font;
if(MyFont->Execute()) SCalPopup1->Font = MyFont->Font;
delete MyFont;
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::ButtonFontCEEditClick(TObject *Sender)
{
MyFont = new TFontDialog(Application);
MyFont->Font = SCalEdit1->Font;
if(MyFont->Execute()) SCalEdit1->Font = MyFont->Font;
delete MyFont;
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::ButtonFontCECalClick(TObject *Sender)
{
MyFont = new TFontDialog(Application);
MyFont->Font = SCalEdit1->Calendar->Font;
if(MyFont->Execute()) SCalEdit1->Calendar->Font = MyFont->Font;
delete MyFont;
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::gbBorderClick(TObject *Sender)
{
  switch(gbBorder->ItemIndex){
    case 0:{
      SCalControl1->BorderStyle=bsNone;
      SCalPopup1->BorderStyle=bsNone;
      SCalEdit1->Calendar->BorderStyle=bsNone; break;}
    case 1:{
      SCalControl1->BorderStyle=bsSingle;
      SCalControl1->Ctl3D=False;
      SCalPopup1->BorderStyle=bsSingle;
      SCalPopup1->Ctl3D=False;
      SCalEdit1->Calendar->BorderStyle=bsSingle;
      SCalEdit1->Calendar->Ctl3D=False; break;}
    case 2:{
      SCalControl1->BorderStyle=bsSingle;
      SCalControl1->Ctl3D=True;
      SCalPopup1->BorderStyle=bsSingle;
      SCalPopup1->Ctl3D=True;
      SCalEdit1->Calendar->BorderStyle=bsSingle;
      SCalEdit1->Calendar->Ctl3D=True; break;}}
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::cbNoTodayClick(TObject *Sender)
{
 SCalControl1->Options->NoToday=cbNoToday->Checked;
 SCalPopup1->Options->NoToday=cbNoToday->Checked;
 SCalEdit1->Calendar->Options->NoToday=cbNoToday->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::cbWeekNumbersClick(TObject *Sender)
{
 SCalControl1->Options->WeekNumbers=cbWeekNumbers->Checked;
 SCalPopup1->Options->WeekNumbers=cbWeekNumbers->Checked;
 SCalEdit1->Calendar->Options->WeekNumbers=cbWeekNumbers->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::cbMultiSelectClick(TObject *Sender)
{
 SCalControl1->Options->MultiSelect=cbMultiSelect->Checked;
 SCalPopup1->Options->MultiSelect=cbMultiSelect->Checked;
 SCalEdit1->Calendar->Options->MultiSelect=cbMultiSelect->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::SCalControl1SelectDate(TObject *Sender)
{
 StartDate->Text=FormatDateTime("ddddd",SCalControl1->SelDate);
 EndDate->Text=FormatDateTime("ddddd",SCalControl1->SelDateEnd);
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::StartDateExit(TObject *Sender)
{
 SCalControl1->SelDate=StrToDate(StartDate->Text);
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::EndDateExit(TObject *Sender)
{
 SCalControl1->SelDateEnd=StrToDate(EndDate->Text);
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::SCalEdit1SelectDate(TObject *Sender)
{
 ceStartDate->Text=FormatDateTime("ddddd",SCalEdit1->SelDate);
 ceEndDate->Text=FormatDateTime("ddddd",SCalEdit1->SelDateEnd);
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::SCalEdit1SelectTime(TObject *Sender)
{
 ceStartDate->Text=FormatDateTime(LongTimeFormat,SCalEdit1->SelTime);
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::ceStartDateExit(TObject *Sender)
{
 if(rgModeDT->ItemIndex == 0)
   SCalEdit1->SelDate=StrToDate(ceStartDate->Text);
 else SCalEdit1->SelTime=StrToTime(ceStartDate->Text);
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::ceEndDateExit(TObject *Sender)
{
 SCalEdit1->SelDateEnd=ceEndDate->Text;
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::rgShowButtonClick(TObject *Sender)
{
  switch(rgShowButton->ItemIndex){
    case 0: SCalEdit1->ButtonShow=btnShowYes; break;
    case 1: SCalEdit1->ButtonShow=btnShowNo; break;
    case 2: SCalEdit1->ButtonShow=btnShowFocus; break;}
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::rgButtonPosClick(TObject *Sender)
{
  switch(rgButtonPos->ItemIndex){
    case 0: SCalEdit1->ButtonAlign=btnRight; break;
    case 1: SCalEdit1->ButtonAlign=btnLeft; break;}
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::rgModeDTClick(TObject *Sender)
{
  switch(rgModeDT->ItemIndex){
    case 0: {SCalEdit1->Width=185; SCalEdit1->TextOffset=0;
       SCalEdit1->Alignment=taLeftJustify;
       SCalEdit1->DisplayMode=dmDate;
       rgShowButton->Enabled=True;
       rgShowButton->ItemIndex=0;
       cbSpin->Checked=False;
       ceStartDate->EditMask="!99/99/00;1; ";
       Label5->Caption="Start Date";
       SCalEdit1SelectDate(NULL); break;}
    case 1: {SCalEdit1->Width=98; SCalEdit1->TextOffset=13;
       SCalEdit1->Alignment=taRightJustify;
       SCalEdit1->DisplayMode=dmTime;
       rgShowButton->ItemIndex=1;
       rgShowButton->Enabled=False;
       cbSpin->Checked=True;
       ceStartDate->EditMask="!90:00:00 >LL;1; ";
       Label5->Caption="Time";
       SCalEdit1SelectTime(NULL); break;}}
  SCalEdit1->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::rgBorderStyle2Click(TObject *Sender)
{
  switch(rgBorderStyle2->ItemIndex){
    case 0:{SCalEdit1->ParentColor=True;
            SCalEdit1->BorderStyle=bsNone; break;}
    case 1:{SCalEdit1->Color=clWindow;
            SCalEdit1->BorderStyle=bsSingle;
            SCalEdit1->Ctl3D=False; break;}
    case 2:{SCalEdit1->Color=clWindow;
            SCalEdit1->BorderStyle=bsSingle;
            SCalEdit1->Ctl3D=True; break;}}
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::cbFloatClick(TObject *Sender)
{
 SCalEdit1->Calendar->FloatCalendar=cbFloat->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::cbQuickClick(TObject *Sender)
{
 if(cbQuick->Checked){
   SCalEdit1->SpinChangeType=stSection;
   ShowMessage("You can now use the arrow keys to change the date/time.");
   SCalEdit1->SetFocus();}
 else{SCalEdit1->SpinChangeType=Scalset::stNone;
   cbSpin->OnClick=NULL; cbSpin->Checked=cbQuick->Checked;
   cbSpin->OnClick=cbSpinClick;}
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::cbSpinClick(TObject *Sender)
{
 SCalEdit1->SpinButtons=cbSpin->Checked;
 if(cbSpin->Checked){cbQuick->OnClick=NULL;
   SCalEdit1->SpinChangeType=stSection;
   cbQuick->Checked=cbSpin->Checked;
   cbQuick->OnClick=cbQuickClick;}
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::SCalEdit1DblClick(TObject *Sender)
{
 SCalEdit1->DisplayForm(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::Label8DblClick(TObject *Sender)
{
 TPoint r;
 r=Point(Panel2->Left,Panel2->Top);
 r=frmDemo1->ClientToScreen(r);
 SCalPopup1->Visible=False;
 SCalPopup1->SelDate=Now();
 SCalPopup1->CalLeft=r.x;
 SCalPopup1->CalTop=r.y;
 SCalPopup1->Execute(Bevel1);
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::FocusOnClickClick(TObject *Sender)
{
 SCalControl1->FocusOnClick=FocusOnClick->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::MaskEdit1DblClick(TObject *Sender)
{
 SCalPopup1->Visible=False;
 SCalPopup1->CalLeft=-1; SCalPopup1->CalTop=-1;
 SCalPopup1->SelDate=StrToDateTime(static_cast<TMaskEdit*>(Sender)->Text);
 SCalPopup1->NumMonthsDown=1; SCalPopup1->NumMonthsAcross=2;
 SCalPopup1->Execute(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::MaskEdit2DblClick(TObject *Sender)
{
 SCalPopup1->Visible=False;
 SCalPopup1->CalLeft=-1; SCalPopup1->CalTop=-1;
 SCalPopup1->SelDate=StrToDateTime(static_cast<TMaskEdit*>(Sender)->Text);
 SCalPopup1->NumMonthsDown=1; SCalPopup1->NumMonthsAcross=1;
 SCalPopup1->Execute(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::MaskEdit3DblClick(TObject *Sender)
{
 SCalPopup1->Visible=False;
 SCalPopup1->CalLeft=-1; SCalPopup1->CalTop=-1;
 SCalPopup1->SelDate=StrToDateTime(static_cast<TMaskEdit*>(Sender)->Text);
 SCalPopup1->NumMonthsDown=2; SCalPopup1->NumMonthsAcross=2;
 SCalPopup1->Execute(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::MaskEdit4DblClick(TObject *Sender)
{
 SCalPopup1->Visible=False;
 SCalPopup1->CalLeft=-1; SCalPopup1->CalTop=-1;
 SCalPopup1->SelDate=StrToDateTime(static_cast<TMaskEdit*>(Sender)->Text);
 SCalPopup1->NumMonthsDown=2; SCalPopup1->NumMonthsAcross=2;
 SCalPopup1->Execute(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::SCalPopup1SelectDate(TObject *Sender)
{
 if(Sender->ClassNameIs("TMaskEdit"))
  static_cast<TMaskEdit*>(Sender)->Text=
  FormatDateTime("ddddd",SCalPopup1->SelDate);
}
//---------------------------------------------------------------------------
void __fastcall TfrmDemo1::cpFloatClick(TObject *Sender)
{
 SCalPopup1->FloatCalendar=cpFloat->Checked;
}
//---------------------------------------------------------------------------
